document.addEventListener("wheel", function (e) {
  if (e.deltaY < -25 && window.lastWheelDirection != "down") {
    window.lastWheelDirection = "down";
    toggleMenbuarOnlyMode(false);
  } else if (e.deltaY > 25 && window.lastWheelDirection != "up") {
    window.lastWheelDirection = "up";
    toggleMenbuarOnlyMode(true);
  }
});

function toggleMenbuarOnlyMode(mode) {
  if (mode === true) {
    document
      .getElementById("BTTNotchMenuBar")
      .classList.add("BTTNotchMenuBarBig");
    document.getElementById("BTTNotchBar").classList.add("BTTNotchBarSmall");
    document
      .getElementById("BTTNotchBar")
      .classList.remove("BTTNotchBarBigAgain");
    document
        .getElementById("BTTNotchMenuBar")
        .classList.add("BTTNotchMenuBarBig");
      
    const statusBarItems = document.getElementsByClassName("statusbar-item");
      for(let statusBarItem of statusBarItems) {
          statusBarItem.style.display = 'none';
      }

    window.menubarOnlyMode = false;
    callBTT("set_window_level", { level: 24 });
    const menubarButtons = document.getElementsByClassName("menubar-button");
    for (const button of menubarButtons) {
      button.style.bottom = "10px";
    }
  } else {
      const statusBarItems = document.getElementsByClassName("statusbar-item");
        for(let statusBarItem of statusBarItems) {
            statusBarItem.style.display = 'unset';
        }
    document
      .getElementById("BTTNotchMenuBar")
      .classList.remove("BTTNotchMenuBarBig");
    document.getElementById("BTTNotchBar").classList.remove("BTTNotchBarSmall");
    document.getElementById("BTTNotchBar").classList.add("BTTNotchBarBigAgain");

    document.getElementById("BTTNotchBar").style.display = "flex";
    const menubarButtons = document.getElementsByClassName("menubar-button");
    for (const button of menubarButtons) {
      button.style.bottom = "0px";
    }
    window.menubarOnlyMode = true;
    callBTT("set_window_level", { level: 1000 });
  }
}

function removeManualHover() {
    const menubarButtons = document.getElementsByClassName("manualhover");

    for (const button of menubarButtons) {
        button.classList.remove("manualhover");
    }
}

function addStatusBarItem(container, base64, x , y, elementID) {
    let img = document.getElementById(elementID);

    const rightStatic = document.getElementById(container);
    // create html image tag using js
    if(!img) {
        img = document.createElement("img");
        img.id = elementID;
        img.alt = 'status icon';
        img.setAttribute('x',x);

        img.setAttribute('x-apple-data-detectors', 'false');
       // set class for img tag
        img.classList.add("statusbar-item");
        img.onmouseup = function() {
         callBTT('click_through', {"x": x, "y" : y});
        };
        
        rightStatic.appendChild(img);
        
        let children = Array.prototype.slice.call(rightStatic.children, 0);

        children.sort(function(a, b) {
            var aord = +a.getAttribute('x');
            var bord = +b.getAttribute('x');
            return aord - bord;
        });

        rightStatic.innerHTML = "";

   
        for(var i = 0, l = children.length; i < l; i++) {
            rightStatic.appendChild(children[i]);
        }
    }
    img.src = `data:image/png;base64,${base64}`;
   
   // assign onmousedown action to img tag
 
    
    
}

function highlightElementAt(x, y) {
  if (window.elementMouseIsOver) {
    window.elementMouseIsOver.classList.remove("manualhover");
  }
  window.elementMouseIsOver = document.elementFromPoint(x, y);

  if (window.elementMouseIsOver) {
      window.elementMouseIsOver.classList.add("manualhover");
  }
}

function updateMenubar(menubarArray) {
  const menubarElement = document.getElementById("BTTNotchMenuBar");
  let htmlString = "";
  let i = 0;
  for (let item of menubarArray) {
    htmlString += `<div class="menubar-button" style="position: absolute; left: ${
      item.x
    }; width:${i === 0 ? "40" : item.width}px; font-weight: ${
      i === 1 ? "bold" : "unset"
    };" onclick="callBTT('click_through', {})">
                      ${item.title}
                    </div>`;
    i++;
  }

  menubarElement.innerHTML = htmlString;

  const menubarButtons = document.getElementsByClassName("menubar-button");

  for (const button of menubarButtons) {
    if (window.menubarOnlyMode === undefined || window.menubarOnlyMode === true) {
      button.style.bottom = "0px";
    } else {
      button.style.bottom = "10px";
    }
  }
}

function addOrUpdatNotchBarButton(buttonDesc) {
  const buttonElement = document.getElementById(buttonDesc.id);
  if (buttonElement) {
    buttonElement.style.left = buttonDesc.x;
    buttonElement.style.width = buttonDesc.width;
    buttonElement.style.backgroundColor = buttonDesc.backgroundColor;
    buttonElement.style.color = buttonDesc.color;
    buttonElement.innerHTML = buttonDesc.title;
  } else {
    const buttonElement = document.createElement("div");
    buttonElement.id = buttonDesc.id;
    buttonElement.style.position = "absolute";
    buttonElement.style.left = buttonDesc.x;
    buttonElement.style.width = buttonDesc.width;
    buttonElement.style.backgroundColor = buttonDesc.backgroundColor;
    buttonElement.style.color = buttonDesc.color;
    buttonElement.innerHTML = buttonDesc.title;
    document.body.appendChild(buttonElement);
  }
}
